const config = require('../../config');
const providers = config.providers;
const crypto = require('crypto');
const bcrypt = require('bcrypt');
const moment = require('moment');

module.exports = function (sequelize, DataTypes) {
  const relatorios_analiticos_video = sequelize.define(
    'relatorios_analiticos_video',
    {
      id: {
        type: DataTypes.UUID,
        defaultValue: DataTypes.UUIDV4,
        primaryKey: true,
      },

      json_analise: {
        type: DataTypes.TEXT,
      },

      data_geracao: {
        type: DataTypes.DATE,
      },

      importHash: {
        type: DataTypes.STRING(255),
        allowNull: true,
        unique: true,
      },
    },
    {
      timestamps: true,
      paranoid: true,
      freezeTableName: true,
    },
  );

  relatorios_analiticos_video.associate = (db) => {
    /// loop through entities and it's fields, and if ref === current e[name] and create relation has many on parent entity

    db.relatorios_analiticos_video.hasMany(db.relatorio_andamento_atual, {
      as: 'relatorio_andamento_atual_ultimo_relatorio_video',
      foreignKey: {
        name: 'ultimo_relatorio_videoId',
      },
      constraints: false,
    });

    //end loop

    db.relatorios_analiticos_video.belongsTo(db.inspecao_aerea, {
      as: 'inspecao',
      foreignKey: {
        name: 'inspecaoId',
      },
      constraints: false,
    });

    db.relatorios_analiticos_video.belongsTo(db.clientes, {
      as: 'clientes',
      foreignKey: {
        name: 'clientesId',
      },
      constraints: false,
    });

    db.relatorios_analiticos_video.belongsTo(db.users, {
      as: 'createdBy',
    });

    db.relatorios_analiticos_video.belongsTo(db.users, {
      as: 'updatedBy',
    });
  };

  return relatorios_analiticos_video;
};
